(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('react'), require('react-dom'), require('office-ui-fabric-react/lib/Label'), require('office-ui-fabric-react/lib/Fabric')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/common', 'react', 'react-dom', 'office-ui-fabric-react/lib/Label', 'office-ui-fabric-react/lib/Fabric'], factory) :
	(factory((global['ng-fabric-ui'] = {}),global.ng.core,global.ng.common,global.React,global.ReactDOM,global.Label,global.Fabric));
}(this, (function (exports,core,common,react,reactDom,Label,Fabric) { 'use strict';

var __decorate$1 = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
        return Reflect.metadata(k, v);
};
exports.ɵa = (function () {
    function FabricLabelComponent(hostRef) {
        this.hostRef = hostRef;
        this.content = '';
    }
    FabricLabelComponent.prototype.ngAfterViewInit = function () {
        this.render();
    };
    FabricLabelComponent.prototype.ngOnChanges = function (changes) {
        var _this = this;
        Object.keys(changes).some(function (prop) {
            var change = changes[prop];
            if (!change.isFirstChange() &&
                change.currentValue !== change.previousValue) {
                _this.render();
                // We only need to call render once, since that will pick up
                // all changes from the Inputs. This exists the some loop by
                // returning true.
                return true;
            }
        });
    };
    FabricLabelComponent.prototype.render = function () {
        var hostElement = this.hostRef.nativeElement;
        var LabelPage = react.createElement(Fabric.Fabric, {}, react.createElement(Label.Label, {
            disabled: this.disabled,
            required: this.required
        }, this.content));
        reactDom.render(LabelPage, hostElement);
    };
    return FabricLabelComponent;
}());
__decorate$1([
    core.Input(),
    __metadata("design:type", Boolean)
], exports.ɵa.prototype, "disabled", void 0);
__decorate$1([
    core.Input(),
    __metadata("design:type", Boolean)
], exports.ɵa.prototype, "required", void 0);
__decorate$1([
    core.Input(),
    __metadata("design:type", Object)
], exports.ɵa.prototype, "content", void 0);
exports.ɵa = __decorate$1([
    core.Component({
        selector: 'fabric-ui-label',
        template: "\n    <div></div>\n  ",
        styles: [""],
        changeDetection: core.ChangeDetectionStrategy.OnPush,
        encapsulation: core.ViewEncapsulation.None
    }),
    __metadata("design:paramtypes", [core.ElementRef])
], exports.ɵa);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
exports.FabricLabelModule = (function () {
    function FabricLabelModule() {
    }
    return FabricLabelModule;
}());
exports.FabricLabelModule = __decorate([
    core.NgModule({
        imports: [
            common.CommonModule,
        ],
        declarations: [exports.ɵa],
        exports: [exports.ɵa]
    })
], exports.FabricLabelModule);

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-fabric-ui.umd.js.map
