import { ChangeDetectionStrategy, Component, ElementRef, Input, NgModule, ViewEncapsulation } from '@angular/core';
import { CommonModule } from '@angular/common';
import { createElement } from 'react';
import { render } from 'react-dom';
import { Label as Label$1 } from 'office-ui-fabric-react/lib/Label';
import { Fabric as Fabric$1 } from 'office-ui-fabric-react/lib/Fabric';

var __decorate$1 = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
let FabricLabelComponent = class FabricLabelComponent {
    constructor(hostRef) {
        this.hostRef = hostRef;
        this.content = '';
    }
    ngAfterViewInit() {
        this.render();
    }
    ngOnChanges(changes) {
        Object.keys(changes).some((prop) => {
            const change = changes[prop];
            if (!change.isFirstChange() &&
                change.currentValue !== change.previousValue) {
                this.render();
                // We only need to call render once, since that will pick up
                // all changes from the Inputs. This exists the some loop by
                // returning true.
                return true;
            }
        });
    }
    render() {
        const hostElement = this.hostRef.nativeElement;
        const LabelPage = createElement(Fabric$1, {}, createElement(Label$1, {
            disabled: this.disabled,
            required: this.required
        }, this.content));
        render(LabelPage, hostElement);
    }
};
__decorate$1([
    Input(),
    __metadata("design:type", Boolean)
], FabricLabelComponent.prototype, "disabled", void 0);
__decorate$1([
    Input(),
    __metadata("design:type", Boolean)
], FabricLabelComponent.prototype, "required", void 0);
__decorate$1([
    Input(),
    __metadata("design:type", Object)
], FabricLabelComponent.prototype, "content", void 0);
FabricLabelComponent = __decorate$1([
    Component({
        selector: 'fabric-ui-label',
        template: `
    <div></div>
  `,
        styles: [``],
        changeDetection: ChangeDetectionStrategy.OnPush,
        encapsulation: ViewEncapsulation.None
    }),
    __metadata("design:paramtypes", [ElementRef])
], FabricLabelComponent);

var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
let FabricLabelModule = class FabricLabelModule {
};
FabricLabelModule = __decorate([
    NgModule({
        imports: [
            CommonModule,
        ],
        declarations: [FabricLabelComponent],
        exports: [FabricLabelComponent]
    })
], FabricLabelModule);

/**
 * Generated bundle index. Do not edit.
 */

export { FabricLabelComponent as ɵa, FabricLabelModule };
//# sourceMappingURL=ng-fabric-ui.js.map
